// WEIGHT conversion
#define gm2kg 0.001           // g to kg
#define kg2gm 1000.0          // kilograms to grams
#define mg2gm 0.001           // mg to grams
#define t2g   1.0e6           // tonnes to grams
#define g2t   1.0e-6          // grams to tonnes
#define t2kg  1000.0          // tonnes to kilograms
#define kg2t  0.001           // kilograms to tonnes


// AREA conversion
#define ha2scm 1.0e8          // ha to sq cm
#define ha2sm  1.0e4          // hectares to sq metres
#define sm2ha  1.0e-4         // m^2 to hectares
#define sm2smm 1.0e6          // square metres to square mm
#define smm2sm 1.0e-6         // mm^2 to m^2
#define scm2smm 100.0         // cm^2 to mm^2


// PRESSURE and related conversion
#define g2mm   1.0e-3         // g water/m^2 to mm water
// 1 g water 1,000 cubic mm and
// 1 sq m 1,000,000 sq mm
#define mb2kpa 0.1            // pressure mbar to kpa
// 1000 mbar 100 kpa

// LENGTH conversion
#define cm2mm 10.0            // cm to mm
#define mm2cm 0.1             // mm to cm
#define mm2m  0.001           // mm to m
#define km2m  1000.0          // km to metres


// VOLUME conversion
#define cmm2cc      0.001    // cubic mm to cubic cm
#define gmPsm2kgPha 100.0    // g/sm -> kg/ha
#define pcnt2fract  0.01     // percent to fraction
#define fract2pcnt  100.0    // fraction to percent
#define mm2lPsm     1.0      // mm depth to litres per sq m
#define lPsm2mm     1.0      // litres per sq m to mm depth

// TIME conversion
#define day2hr      24.0     // days to hours
#define hr2s        3600     // hours to seconds
#define s2hr        2.78e-4  // seconds to hours
